var pivot;

function getReport()
{
    var reportData = pivot.getReport();
    return reportData;
}

function setSlice(sliceData)
{
    var reportData = pivot.getReport();
    reportData.slice = sliceData;
    pivot.setReport(reportData);
}

function setReportData(sliceData, optionData, conditionData, formatData)
{
    var reportData = pivot.getReport();
    reportData.slice = sliceData;
    reportData.options = optionData;
    reportData.conditions = conditionData;
    reportData.formats = formatData;
    pivot.setReport(reportData);
}

function setTableData(tableDataJson)
{
    pivot.updateData({ data: tableDataJson });
}

function selectedCellOrCells()
{
    return pivot.getSelectedCell();
}

function showFieldsDialog()
{
    return pivot.openFieldsList();
}

function showGrid()
{
    pivot.showGrid();
}

function showChartType(chartType, showGridAndChart)
{
    if (showGridAndChart)
    {
        pivot.showGridAndCharts(chartType, "right", true);
    }
    else
    {
        pivot.showCharts(chartType, true);
    }
}

function showOptions()
{
    pivot.toolbar.showOptionsDialog();
}

function showFormat()
{
    pivot.toolbar.formatCellsHandler();
}

function loadPivotDataFromJSONString(jsonData,
                                     sliceData,
                                     optionData,
                                     conditionData,
                                     formatData,
                                     fmKey,
                                     showToolbar)
{
    pivot = new Flexmonster(
                            {
                                container: "pivot-container",
                                toolbar: showToolbar,
                                width: "100%",
                                height: "100%",
                                report:
                                {
                                    dataSource:
                                    {
                                        data: jsonData
                                    },
                                    slice: sliceData,
                                    options: optionData,
                                    conditions: conditionData,
                                    formats: formatData
                                },
                                cellclick : function (cell)
                                {
                                    window.webkit.messageHandlers.callback.postMessage("cellclick");
                                },
                                reportchange : function()
                                {
                                    window.webkit.messageHandlers.callback.postMessage("reportchange");
                                },
                                reportcomplete : function()
                                {
                                    window.webkit.messageHandlers.callback.postMessage("reportcomplete");
                                },
                            
                                licenseKey: fmKey
                            });
}
